import React from 'react';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Button, Input, Select, Spin, Table, message, Modal ,Popconfirm} from 'antd';

const Assign=React.createClass({
    departmentList() {
		this.setState({
			loading: true
		});
		$.ajax({
			method: "get",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context + "/api/admin/organization/selectSuperId",
			data: {
				
			},
			success: function(data) {
				let thedata = data.data;
				let theArr=[];
				if(!thedata) {
					if(data.error && data.error.length) {
						message.warning(data.error[0].message);
					};
					thedata = {};
				}else{
					thedata.map(function(item,index){
						theArr.push({
							key:index,
							name:item.name,
							id:item.id,
						})
					})
				}
				this.setState({
					departmentArr:theArr,
				})
			}.bind(this),
			}).always(function() {
				this.setState({
					loading: false
				});
			}.bind(this));
	},
    getInitialState() {
        return {
            contact:0,
            selectedRows: [],
            searchMore: true,
            loading: false,
            visible:false,
            showDesc:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            userList:[
            	{
                    title: '用户姓名',
                    dataIndex: 'name',
                    key: 'name',
                    width:100
                },{
                    title: '部门机构',
                    dataIndex: 'departmentName',
                    key: 'departmentName',
                    width:100,
                    render:text=>{
                        return text&&text.length>12?<span title={text}>{text.substr(0,12)+'...'}</span>:text
                    }
                }, {
                    title: '职务',
                    dataIndex: 'position',
                    key: 'position',
                    width:100
                },{
                    title: '联系手机',
                    dataIndex: 'contactMobile',
                    key: 'contactMobile',
                    width:100
                }, {
                    title: '操作',
                    dataIndex: 'abc',
                    key: 'abc',
                    width:100,
                    render:(text,record,index)=>{
                    	return (
                                <Popconfirm title={'您确认将(订单/任务/项目) 【'+this.props.data.orderNo+'】 分配给【'+record.departmentName+'-'+record.name+'】？'} onConfirm={(e)=>{this.confirmSelect(record)}} okText="确认" cancelText="取消">
                                    <Button style={{marginRight:'5px'}} type="primary">选定</Button>                 
                                </Popconfirm>
							)
                    }
                }
            ],
            dataSource: [],
        };
    },
    //操作分配
    confirmDelet(index){
    	this.setState({
    		orderNos:index.orderNo,
    	});
    },
    onCancel(){
    	this.setState({
    		visible:false
        })
        this.props.closeDesc(false,false);
    },
    onShow() {
		this.setState({
			visible: false,
		});
		this.props.closeDesc(false, true);
	},
    //分配对象列表
    contactList(){
        this.setState({
            loading:true
        });
        let api = this.state.contact?'/api/admin/frequentContactsList':'/api/admin/superviser/adminList';
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + api,
            data: {
                pageNo: 1,
                pageSize: 99,
                departmentId:this.state.departmenttList,
                name:this.state.financeNameSearch,
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
                             id: thisdata.id,
                             contactId:thisdata.contactId,
	                         userNo: thisdata.userNo,
	                         name:thisdata.name,
	                         departmentName:thisdata.departmentName,
	                         departmentId:thisdata.departmentId,
	                         position:thisdata.position,
	                         contactMobile:thisdata.contactMobile,
                        });
                    };
                };
                this.setState({
                    distributionList: theArr,
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    //选定对象
    confirmSelect(record){
    	this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context +this.props.selApi,
            data: {
            	orderNo:this.props.data.orderNo,
                financeId: !this.state.contact?record.id:record.contactId,    //分配人物id
                approval:this.props.data.approval   //是否特批
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('派单成功');
                this.onShow();
            } else {
                message.warning(data.error[0].message);
            };
            this.setState({
                loading: false,
            });
        }.bind(this));
    },
    searchOrder(){
    	this.contactList();
    },
    resetOrder(){
    	this.state.departmenttList=undefined;
        this.state.financeNameSearch='';
        this.state.contact=0;
    	this.setState({
    		distributionList:[]
    	});
    },
    componentWillMount() {
    },
    componentWillReceiveProps(nextProps) {
        this.state.visible=nextProps.showDesc;
        if(nextProps.showDesc){
            this.departmentList();
        }
        this.setState({
            contact:0
        })
    },
    render() {
        let departmentArr = this.state.departmentArr || [];
        return (
            <div className="user-content" >
	            <Modal maskClosable={false} visible={this.state.visible}
                        onOk={this.onShow} onCancel={this.onCancel}
                        width='800px'
                        title='选择'                     
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" onSubmit={this.handleSubmit} id="demand-form" style={{paddingBottom:'40px'}} >
			                <Spin spinning={this.state.loading}>
			                	<div>
                                    <span style={{marginRight:5}}>常用联系人:</span>
                                    <Radio.Group onChange={(e)=>{this.setState({contact:e.target.value})}} value={this.state.contact}>
                                        <Radio value={0}>否</Radio>
                                        <Radio value={1}>是</Radio>
                                    </Radio.Group>
			                		<Select placeholder="部门"
				                            style={{ width: 150 ,marginRight:'10px',marginLeft:'10px'}}
				                            value={this.state.departmenttList}
				                            onChange={(e) => { this.setState({ departmenttList: e }) }}>
				                            {
			                                    departmentArr.map(function (item) {
			                                            return <Select.Option key={item.id} >{item.name}</Select.Option>
			                                    })
			                                }
				                    </Select>
				                    <Input placeholder="姓名" style={{width:'150px',marginLeft:'10px'}}
				                        value={this.state.financeNameSearch}
				                        onChange={(e) => { this.setState({ financeNameSearch: e.target.value }); }} />  
				                    <Button type="primary" onClick={this.searchOrder} style={{marginLeft:'10px',marginRight:'10px'}}>搜索</Button>
	                    			<Button onClick={this.resetOrder}>重置</Button>
			                	</div>
			                	 <div className="patent-table" style={{marginTop:'10px'}}>
				                    <Spin spinning={this.state.loading}>
				                        <Table columns={this.state.userList}
				                            dataSource={this.state.distributionList}
                                            pagination={false}
                                            scroll={{y:400}}
				                             />
				                    </Spin>
				                </div>
			                </Spin>
			            </Form>
			    </Modal>
            </div>
        );
    }
});

export default Assign;